import java.util.Random;

import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;

public class Consumer implements Runnable {

  private final EnergySource src;
  private final int id;
  private final Random r = new Random();

  private static final Lock monitor = new ReentrantLock();

  public Consumer(int id, EnergySource src) {
    this.id = id;
    this.src = src;
  }

  public void run() {
    for (int i = 0; i < 10; i++) {
      monitor.lock();
      try {
        long amountToConsume = (long)r.nextInt((int)src.getUnitsAvailable());
        System.out.print("Consumer " + id + " tries to consume");
        System.out.print(" " + amountToConsume + ": ");
        boolean result = src.useEnergy(amountToConsume);
        if (result) {
          System.out.println(" SUCCESS!");
        } else {
          System.out.println(" FAIL!");
        }
      } finally {
        monitor.unlock();
      }
      try {
        Thread.sleep(r.nextInt(3000));
      } catch (Exception ex) {
      }
    }
  }

}
